//-------------------------------------------------------------------------------
// CCubo.h
//-------------------------------------------------------------------------------

#ifndef CCUBO_H
#define CCUBO_H

#define D3DFVF_VERTCUBO (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1)

#include <d3dx9.h>
#include "principal.h"

//-------------------------------------------------------------------------------
// Clase: CCubo
//-------------------------------------------------------------------------------

class CCubo  
{
	private:
		
		struct VERTCUBO
		{
			FLOAT x, y, z;			
			DWORD color;
			FLOAT tu, tv;
		};

		BOOL ActualizarVertices();
		HRESULT CrearBufferVert();
		LPDIRECT3DDEVICE9 D3DDisp;
		LPDIRECT3DVERTEXBUFFER9 BufferVert;
		LPDIRECT3DTEXTURE9 m_pTextura;
		float Ancho;
		float Alto;
		float Largo;
		float m_rX;
		float m_rY;
		float m_rZ;

		void CargarEstados(void);

		
	public:

		BOOL Posicion(float x, float y, float z);
		BOOL Dimensiones(float rAncho, float rAlto, float rLargo);
		HRESULT Textura(const char* szArchivo);
		BOOL Renderizar();
		HRESULT Inicializar(LPDIRECT3DDEVICE9 pD3DDevice);
		CCubo(void);
		~CCubo();
};

#endif // CCUBO_H