//-------------------------------------------------------------------------------
// CUtil.cpp
//-------------------------------------------------------------------------------

#include "CUtil.h"

//-------------------------------------------------------------------------------
// Funcin: Constructor
//-------------------------------------------------------------------------------
CUtil::CUtil(HWND Wnd,void *DebInHandle,void *DebOutHandle)
{
	hWnd=Wnd;
	debugInputHandle=DebInHandle;
	debugOutputHandle=DebOutHandle;
	srand((unsigned)time(NULL));
	LogActivado=TRUE;
}

//-------------------------------------------------------------------------------
// Funcin: Mostrar
// Propsito: Muestra un message box con el texto introducido
//-------------------------------------------------------------------------------
void CUtil::Mostrar(char cadena[128])
{
	MessageBox(hWnd,cadena,"Info",MB_OK|MB_ICONEXCLAMATION);
}

//-------------------------------------------------------------------------------
// Funcin: RandInt
// Propsito: Devuelve un nmero entero aleatorio entre dos introducidos,el alto
//			  excluido y el bajo incluido.	
//-------------------------------------------------------------------------------
int CUtil::RandInt(int bajo,int alto)
{
	int rango=alto-bajo;
    int num=rand()%rango;
    return(num+bajo);
}

//-------------------------------------------------------------------------------
// Funcin: DesactivarLog
// Propsito: Desactiva el Logbook
//-------------------------------------------------------------------------------
void CUtil::DesactivarLog(void)
{
	LogActivado = FALSE;
}

//-------------------------------------------------------------------------------
// Funcin: ActivarLog
// Propsito: Activa el logbook creando un archivo nuevo
//-------------------------------------------------------------------------------
void CUtil::ActivarLog(void)
{
	LogActivado = TRUE;
	
	FILE* pFile;

	//Elimina el contenido del archivo
	pFile = fopen("log.txt", "wb");

	//Cerrarlo
	fclose(pFile);
}

//-------------------------------------------------------------------------------
// Funcin: EscribirLog
// Propsito: Escribe en el logbook
//-------------------------------------------------------------------------------
void CUtil::EscribirLog(char *lpszText, ...)
{
	if(LogActivado)
	{
		va_list argList;
		FILE *pFile;

		//Initialize variable argument list
		va_start(argList, lpszText);

		//Open the log file for appending
		pFile = fopen("log.txt", "a+");

		//Write the text and a newline
		vfprintf(pFile, lpszText, argList);
		putc('\n', pFile);

		//Close the file
		fclose(pFile);
		va_end(argList);

		EscribirConsola(" Escribiendo en log.txt . . .\n");
	}
}

//-------------------------------------------------------------------------------
// Funcin: EscribirConsola
// Propsito: Escribe en la consola
//-------------------------------------------------------------------------------
void CUtil::EscribirConsola(char* text, ...)
{
	if (debugOutputHandle)
	{
		static char Buffer[1024];
		va_list args;
		va_start(args,text);
		vsprintf(Buffer,text,args);
		va_end(args);

		DWORD num;
		if (!Buffer)
			return;

		WriteConsole(debugOutputHandle,Buffer,strlen(Buffer),&num,NULL);
	}
}
