//-------------------------------------------------------------------------------
// CCubo.h
//-------------------------------------------------------------------------------

#ifndef CCUBO_H
#define CCUBO_H

#define D3DFVF_VERTCUBO (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX1)

#include <d3dx9.h>
#include "principal.h"

//-------------------------------------------------------------------------------
// Clase: CCubo
//-------------------------------------------------------------------------------

class CCubo  
{
	private:
		
		struct VERTCUBO
		{
			FLOAT x, y, z;			
			FLOAT nx, ny, nz;
			FLOAT tu, tv;
		};

		BOOL ActualizarVertices();
		HRESULT CrearBufferVert();
		D3DVECTOR DaNormalTriangulo(D3DXVECTOR3* vVertice1, D3DXVECTOR3* vVertice2, D3DXVECTOR3* vVertice3);
		void CargarEstados(void);

		LPDIRECT3DDEVICE9		D3DDisp;
		LPDIRECT3DVERTEXBUFFER9 BufferVert;
		LPDIRECT3DTEXTURE9		m_pTextura;
		D3DMATERIAL9			m_matMaterial;
		float Ancho;
		float Alto;
		float Largo;
		float m_rX;
		float m_rY;
		float m_rZ;


		
	public:

		BOOL Posicion(float x, float y, float z);
		BOOL Dimensiones(float rAncho, float rAlto, float rLargo);
		HRESULT Textura(const char* szArchivo);
		BOOL Renderizar();
		HRESULT Inicializar(LPDIRECT3DDEVICE9 pD3DDevice);
		BOOL Material(D3DCOLORVALUE rgbaDifuso, D3DCOLORVALUE rgbaAmbiente, D3DCOLORVALUE rgbaEspecular, D3DCOLORVALUE rgbaEmisivo, float rPotencia);

		CCubo(void);
		~CCubo();
};

#endif // CCUBO_H