//-------------------------------------------------------------------------------
// CJuego.h
//-------------------------------------------------------------------------------

#ifndef CJUEGO_H
#define CJUEGO_H

#include <d3dx9.h>
#include <math.h>
#include "principal.h"
#include "resource.h"
#include "CUtil.h"
#include "CCrono.h"
#include "CCamara.h"
#include "CInput.h"
#include "CFuente.h"
#include "CCubo.h"
#include "CPanel.h"


//-------------------------------------------------------------------------------
// Clase: CJuego
//-------------------------------------------------------------------------------

class CJuego  
{
	private:
		
		void EscribirConsola(char* text, ...);

		LPDIRECT3D9 m_pD3D;
		LPDIRECT3DDEVICE9 m_pD3DDev;
		D3DLIGHT9 Luz;
		CUtil *Util;
		CInput *Input;
		CCrono *Crono;
		CCamara *Camara;
		CFuente *Fuente;
		CCubo *Cubo1;
		CCubo *Cubo2;
		CCubo *Cubo3;
		CCubo *Cubo4;
		CPanel *Destello;
		CPanel *Suelo;
		HWND hWnd;
		void *debugInputHandle;
		void *debugOutputHandle;

		void ActualizaCamara(void);
		BOOL InicializarLuces(void);
		BOOL ActualizarLuces(void);


		

	public:
		
		HRESULT InicializarD3D(BOOL bWindowed);
		HRESULT InicializarJuego();
		D3DFORMAT CJuego::SelModoVideo(UINT nAncho, UINT nAlto, UINT nBits);
		void BuclePpal(void);
		CJuego(HWND Wnd,void *DebInHandle,void *DebOutHandle);
		~CJuego();

};

#endif // CJUEGO_H