//-------------------------------------------------------------------------------
// CPanel.h
//-------------------------------------------------------------------------------

#ifndef CPANEL_H
#define CPANEL_H

#define D3DFVF_VERTPANEL (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX1)

#include <d3dx9.h>
#include "principal.h"

//-------------------------------------------------------------------------------
// Clase: CPanel
//-------------------------------------------------------------------------------

class CPanel  
{
	private:
		
		struct VERTPANEL
		{
			D3DXVECTOR3 p;       // posicion del vertice
			D3DXVECTOR3 n;       // posicion de la normal
			FLOAT u, v;
		};

		BOOL ActualizarVertices();
		HRESULT CrearBufferVert();
		void CargarEstados(void);
		D3DVECTOR DaNormalTriangulo(D3DXVECTOR3* vVertice1, D3DXVECTOR3* vVertice2, D3DXVECTOR3* vVertice3);


		LPDIRECT3DDEVICE9		D3DDisp;
		LPDIRECT3DVERTEXBUFFER9 BufferVert;
		LPDIRECT3DTEXTURE9		m_pTextura;
		D3DMATERIAL9			m_matMaterial;
		float m_rX;
		float m_rY;
		float m_rZ;
		int	  m_iSegmentos;
		BOOL  m_bIluminado;
		BOOL  m_bCanalAlpha;


	public:

		float Ancho;
		float Alto;

		BOOL Posicion(float x, float y, float z);
		BOOL Dimensiones(float rAncho, float rAlto);
		HRESULT Textura(const char* szArchivo);
		BOOL Renderizar();
		void Iluminado(BOOL bIluminar);
		void CanalAlpha(BOOL bCanalAlpha);


		HRESULT Inicializar(LPDIRECT3DDEVICE9 pD3DDevice,int iSegmentos);
		BOOL Material(D3DCOLORVALUE rgbaDifuso, D3DCOLORVALUE rgbaAmbiente, D3DCOLORVALUE rgbaEspecular, D3DCOLORVALUE rgbaEmisivo, float rPotencia);

		CPanel(void);
		~CPanel();
};

#endif // CPANEL_H