//-------------------------------------------------------------------------------
// CFuente.h
//-------------------------------------------------------------------------------

#ifndef CFUENTE_H
#define CFUENTE_H

#define MAX_LONG	1024

#define D3DFVF_VERTFUENTE (D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_TEX1)

#include <d3dx9.h>
#include "principal.h"
#include "CUtil.h"


//-------------------------------------------------------------------------------
// Clase: CFuente
//-------------------------------------------------------------------------------

class CFuente
{

	private:

		struct VERTFUENTE
		{ 
			D3DXVECTOR4		vertice;   
			DWORD			color;     
			float			s, t; 
		};

		CUtil				*Util;

		HRESULT				PintaLetra(float fX,float fY,BYTE c);
		void				CrearTablaCoord(void);
		void				CargarEstados(void);


		int					Ancho;
		int					Alto;

		int					CarPorCol;
		int					CarPorFila;

		int					AnchoPant;
		int					AltoPant;

		DWORD				Color;

		BOOL				Sombra;

		float				IncX;
		float				IncY;

		float				CoordTexto[256][2];

		char				*Archivo;

		LPDIRECT3DDEVICE9	DispD3D;
		LPDIRECT3DTEXTURE9	Textura;

		HWND				hWnd;
		void				*debugInputHandle;
		void				*debugOutputHandle;

	public:

		CFuente(HWND Wnd,void *DebInHandle,void *DebOutHandle);
		~CFuente();

		void Destruir();

		HRESULT CargarFuente(LPDIRECT3DDEVICE9 pD3DDev,char *szFontFile);

		HRESULT PintaTextoUV(int iX,int iY,char *szString,...);
		HRESULT PintaTextoXY(int iX,int iY,char *szString,...);
		HRESULT PintaLineaXY(int iX,int iY,int iAlineacion,char *szString,...);

		void	Dimensiones(int iWidth,int iHeight);
		void	PonerColor(DWORD dwColor);
		void	PonerSombra(BOOL bShadow);
};

#endif // CFUENTE_H
