//-------------------------------------------------------------------------------
// CBitset.cpp
//-------------------------------------------------------------------------------

#include "CBitset.h"

//--------------------------------------------------------------------
// Funcin: Inicializar
// Propsito: Crea la tabla de bits
//--------------------------------------------------------------------
void CBitset::Inicializar(int iNumeroDeBits) 
{ 
	// Obtenemos el numero de integers necesarios
	m_iNumDeInt = iNumeroDeBits/32 + 1;

	// Borramos si ya tuvieramos una tabla
	BorrarObj(m_pBits);

	// Creamos la tabla y la inicilizamos a 0
	m_pBits = new unsigned int[m_iNumDeInt];
	DesactivarTodos();
}

//--------------------------------------------------------------------
// Funcin: Activar
// Propsito: Pone a 1 el bit indicado
//--------------------------------------------------------------------
void CBitset::Activar(int i) 
{
	m_pBits[i >> 5] |= (1 << (i & 31));
}

//--------------------------------------------------------------------
// Funcin: EstaActivado
// Propsito: Devuelve el estado del bit indicado (1  0)
//--------------------------------------------------------------------
int CBitset::EstaActivado(int i) 
{
	return m_pBits[i >> 5] & (1 << (i & 31 ));
}

//--------------------------------------------------------------------
// Funcin: Desactivar
// Propsito: Pone a 0 el bit indicado
//--------------------------------------------------------------------
void CBitset::Desactivar(int i) 
{
	m_pBits[i >> 5] &= ~(1 << (i & 31));
}

//--------------------------------------------------------------------
// Funcin: DesactivarTodos
// Propsito: Pone a 0 todos los bits de la tabla
//--------------------------------------------------------------------
void CBitset::DesactivarTodos(void) 
{
	memset(m_pBits, 0, sizeof(unsigned int) * m_iNumDeInt);
}

//////////////////////////////////////////////////////////////////////
/********************************************************************/
/********************************************************************/
/*						Fin CBitset.cpp								*/
/********************************************************************/
/********************************************************************/