//-------------------------------------------------------------------------------
// CCrono.h
//-------------------------------------------------------------------------------

#ifndef CCRONO_H
#define CCRONO_H

#define ACTUALIZACION_DEL_FPS 0.5f

#include "principal.h"

//-------------------------------------------------------------------------------
// Clase: CCrono
//-------------------------------------------------------------------------------

class CCrono {

	private:

		BOOL   EnMarcha;	

		UINT64 TicksBase;
		UINT64 TicksParado;

		UINT64 TicksPorSegundo;

		float  TiempoFrame;
		float  TiempoDelta;

		DWORD  NumFrames;
		float  UltimaActualizacion;
		float  FPS;

	public:

		CCrono();

		void  Empezar();
		void  Parar();
		void  Continuar();

 		float DaTiempoActual();
		float DaTiempoDelFrame();
		float DaTiempoDelta();

		void  Frame();
		float DaFps();

		BOOL  EstaEnMarcha();
};

#endif // CCRONO_H