//-------------------------------------------------------------------------------
// CInput.h
//-------------------------------------------------------------------------------

#ifndef CINPUT_H
#define CINPUT_H

#define DIRECTINPUT_VERSION  0x0800

#include <dinput.h>
#include "principal.h"

enum MOUSE_BUTTON
{
	BOTON_IZQUIERDO,
	BOTON_DERECHO,
	BOTON_CENTRAL
};

//-------------------------------------------------------------------------------
// Clase: CInput
//-------------------------------------------------------------------------------

class CInput{

	private:

		HRESULT					EstadoDelTeclado(void);
		HRESULT					EstadoDelRaton(void);

		LPDIRECTINPUT8			ObjDinput;
		LPDIRECTINPUTDEVICE8	Teclado;
		LPDIRECTINPUTDEVICE8	Raton;

		BYTE					Teclas[256];
		DIMOUSESTATE2			EstadoRaton;

		int						EstIzqdo,EstDcho,EstCentral;


	public:

		BOOL						PULSADO_IZQUIERDO;
		BOOL						PULSADO_DERECHO;
		BOOL						PULSADO_CENTRAL;

		BOOL						SOLTADO_IZQUIERDO;
		BOOL						SOLTADO_DERECHO;
		BOOL						SOLTADO_CENTRAL;


		CInput();
		~CInput();

		HRESULT Inicializar(HWND hWnd,BOOL RatonExclusivo,BOOL TecladoExclusivo);
		HRESULT Actualizar(void);

		BOOL	TeclaPulsada(int iKey);

		BOOL	BotonPulsado(int iButton);

		int		XRelativaRaton(void);
		int		YRelativaRaton(void);
		int		ZRelativaRaton(void);

		int		XAbsolutaRaton(void);
		int		YAbsolutaRaton(void);
		int		ZAbsolutaRaton(void);

};

#endif // CINPUT_H