//-------------------------------------------------------------------------------
// principal.h
//-------------------------------------------------------------------------------

#if !defined(AFX_PRINCIPAL_H)
#define AFX_PRINCIPAL_H

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <time.h>

//-------------------------------------------------------------------------------
// Definiciones
//-------------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN

#define APP_NAME    "D3D 8 - Parte 1"

#define WND_WIDTH	640
#define WND_HEIGHT	480

#define TEXTO_LONG_MAX  1024
#define TEXTO_DERECHA	1
#define TEXTO_IZQUIERDA	2
#define TEXTO_CENTRO	3

#define NOMBRE_NIVEL						"maps\\prueba.bsp"

#define GFX_OPC_BILINEAR					2		// 0 Nada, 1 Punto, 2 Linear
#define GFX_OPC_MIPMAP						2		// 0 Nada, 1 Punto, 2 Linear
#define GFX_OPC_ANTIALIAS					false
#define GFX_OPC_CAMARAFOV					50.0f	// En grados
#define GFX_OPC_MAXDISTFRUSTUM				300.0f	
#define GFX_OPC_MINDISTFRUSTUM				0.1f
#define GFX_OPC_GAMMA						10		// 0-10  
#define GFX_OPC_RELLENO						3		// 1 Puntos
													// 2 Malla
													// 3 Slido

// Elimina objetos e interfaces de memoria
#define BorrarInter(pInterface) if(pInterface != NULL) {pInterface->Release(); pInterface=NULL;}
#define BorrarObj(pObject) if(pObject != NULL) {delete pObject; pObject=NULL;}

// Nos dice si una tecla determinada ha sido pulsada
#define GET_KEYDOWN(key) ((int)((GetAsyncKeyState(key) & (1 << 15)) >> 15))

#endif

