//-------------------------------------------------------------------------------
// CCamara.h
//-------------------------------------------------------------------------------

#ifndef CCAMARA_H
#define CCAMARA_H

#include <d3dx9.h>

#include "principal.h"

//-------------------------------------------------------------------------------
// Clase: CCamara
//-------------------------------------------------------------------------------

class CCamara
{
	private:
		
		float		m_fFov;

		int			m_iAncho;
		int			m_iAlto;

		float		m_fPitch;
		float		m_fYaw;
		float		m_fRoll;

		float		m_fPlanoCercano;
		float		m_fPlanoLejano;

		D3DXVECTOR3 m_Posicion;

		D3DXVECTOR3	m_Dcha;
		D3DXVECTOR3	m_Arriba;
		D3DXVECTOR3	m_Look;

	public:

		CCamara();
		~CCamara();

		void		ActualizarVista(LPDIRECT3DDEVICE9 pD3DDev);
		void		ActualizarProyeccion(LPDIRECT3DDEVICE9 pD3DDev);

		void		PonerFov(float fFov);
		float		DaFov(void);

		void		PonerDimensiones(int iAncho, int iAlto);

		void		PonerPlanos(float fCerca, float fLejos);

		void		Avanzar(float fVel, float fDTiempo);
		void		Desplazar(float fVel, float fDTiempo);
		void		Subir(float fVel, float fDTiempo);

		void		PonerPosAbs(D3DXVECTOR3 &pos);
		D3DXVECTOR3	DaPosicion(void);

		void		PonerOrientacion(float fPitch, float fYaw, float fRoll);
		D3DXVECTOR3	DaOrientacion(void);

		D3DXVECTOR3	DaVectorDcha(void);
		D3DXVECTOR3	DaVectorArriba(void);
		D3DXVECTOR3	DaVectorLookAt(void);


};

#endif // CCAMARA_H