//-------------------------------------------------------------------------------
// Tutorial del Win32
// PLANET ISO
// http://www.planetiso.cjb.net
//-------------------------------------------------------------------------------

#include <windows.h>

#include "resource.h"

#define WIN32_LEAN_AND_MEAN

//-------------------------------------------------------------------------------
// Definiciones
//-------------------------------------------------------------------------------
#define APP_NAME	"Prueba de Win32"
#define WND_WIDTH	640
#define WND_HEIGHT	480

// Nos dice si una tecla determinada ha sido pulsada
#define GET_KEYDOWN(key) ((int)((GetAsyncKeyState(key) & (1 << 15)) >> 15))

//-------------------------------------------------------------------------------
// Declaracin de funciones
//-------------------------------------------------------------------------------
LRESULT WINAPI MsgProc(HWND, UINT, WPARAM, LPARAM);
INT WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
BOOL CALLBACK ProcedimientoDialogo(HWND hWndDlg,UINT Msg,WPARAM wParam,LPARAM lParam);


HRESULT	IniVentana(HINSTANCE hInstance);

//-----------------------------------------------------------------------------
// Declaracin de variabes globales
//-----------------------------------------------------------------------------
HWND		g_hWnd;				// Nuestra ventana
HINSTANCE	hInst;

//----------------------------------------------------------------------------
// Funcin: IniVentana
// Propsito: Inicializa nuestra ventana
//----------------------------------------------------------------------------
HRESULT IniVentana(HINSTANCE hInstance)
{
	
	WNDCLASSEX	wc;		// clase de ventana
	
	// Rellenamos la estructura de clase de ventana
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_CLASSDC;
	wc.lpfnWndProc = MsgProc;
	wc.cbClsExtra = 0L;
	wc.cbWndExtra = 0L;
	wc.hInstance = GetModuleHandle(NULL);
	wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor = NULL;
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
	wc.lpszClassName = APP_NAME;
	wc.hIconSm = NULL;


	// Registramos la clase de vetana
	if(!RegisterClassEx(&wc))
	{
		MessageBox(NULL, "No se pudo registrar la clase de ventana", "Error", MB_OK|MB_ICONEXCLAMATION);
		return E_FAIL;
	}

	// Creamos la ventana
	g_hWnd = CreateWindow(APP_NAME,				// nombre de la clase
						APP_NAME,				// ttulo de la ventana
						WS_OVERLAPPEDWINDOW,	// tipo de ventana
						CW_USEDEFAULT,			// posicin X de la ventana
						CW_USEDEFAULT,			// posicin Y de a ventana
						WND_WIDTH,				// ancho de la ventana
						WND_HEIGHT,				// alto de la ventana
						GetDesktopWindow(),		// ventana padre
						NULL,					// men
						wc.hInstance,			// instancia de la aplicacin
						NULL);					// no se suele usar

	if (!g_hWnd)
    {
        MessageBox(NULL,"No se cre el objeto g_hWnd","Error",MB_OK|MB_ICONEXCLAMATION);
		return E_FAIL;
    }

	return S_OK;
}

//-------------------------------------------------------------------------------
// Funcin: ProcedimientoDialogo
// Propsito: Manejar el nuevo dialogo de la aplicacin
//-------------------------------------------------------------------------------
BOOL CALLBACK ProcedimientoDialogo(HWND hWndDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	char Mensaje[256], Aux[256];

	//Creamos tres cadenas para el combo box
	char *Cadena[] = {"Nivel 1", "Nivel 2", "Nivel 3"};

	switch(Msg)
	{
		case WM_INITDIALOG:

			//Rellenamos el combo box con las tres cadenas que hemos definido
			SendDlgItemMessage(hWndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) Cadena[0]);
			SendDlgItemMessage(hWndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) Cadena[1]);
			SendDlgItemMessage(hWndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM) Cadena[2]);

			//Ponemos dos frases inciales en el combo box y en el edit box
			SetDlgItemText(hWndDlg, IDC_EDIT1, "Pon tu nombre aqu");
			SetDlgItemText(hWndDlg, IDC_COMBO1, "Indica un nivel aqu");

			//Ponemos el foco en el edit box
			SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));

			return FALSE;

		case WM_CLOSE:
			EndDialog(hWndDlg, TRUE);
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDCANCEL:
					EndDialog(hWndDlg, TRUE);
					break;

				case IDOK:
					//Tomamos el contenido del edit box y lo pasamos a 'Mensaje'
					GetDlgItemText(hWndDlg, IDC_EDIT1, Mensaje, sizeof(Mensaje));
					//Le aadimos parentesis
					strcat(Mensaje, " (");
					//Tomamos el contenido del combo box y lo pasamos a 'Aux'
					GetDlgItemText(hWndDlg, IDC_COMBO1, Aux, sizeof(Aux));
					//Se lo aadimos a 'Mensaje'
					strcat(Mensaje, Aux);
					//Le aadimos parentesis
					strcat(Mensaje, ") (Boton Ok)");
					//Lo mostramos mediante message box
					MessageBox(hWndDlg, Mensaje, "Dilogo", MB_OK);
					//Terminamos el dialogo
					EndDialog(hWndDlg, TRUE);
					break;

				case IDC_PRUEBA:
					//Tomamos el contenido del edit box y lo pasamos a 'Mensaje'
					GetDlgItemText(hWndDlg, IDC_EDIT1, Mensaje, sizeof(Mensaje));
					//Le aadimos parentesis
					strcat(Mensaje, " (");
					//Tomamos el contenido del combo box y lo pasamos a 'Aux'
					GetDlgItemText(hWndDlg, IDC_COMBO1, Aux, sizeof(Aux));
					//Se lo aadimos a 'Mensaje'
					strcat(Mensaje, Aux);
					//Le aadimos parentesis
					strcat(Mensaje, ") (Boton Prueba)");
					//Lo mostramos mediante message box
					MessageBox(hWndDlg, Mensaje, "Dilogo", MB_OK);
					break;

			}

			return TRUE;
	}
	return FALSE;
}

//-------------------------------------------------------------------------------
// Funcin: MsgProc
// Propsito: Manejar los mensajes de la aplicacin
//-------------------------------------------------------------------------------
LRESULT WINAPI MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
		case WM_CREATE: //Inicio de la aplicacion
			MessageBox(hWnd, "La aplicacion ha sido creada.", "Alerta",
					   MB_ICONEXCLAMATION | MB_OK);
			break;

		case WM_QUIT:  //Fin de la aplicacion
			MessageBox(hWnd, "La aplicacin se va a terminar.", "Alerta",MB_ICONEXCLAMATION | MB_OK);

			break;

		case WM_COMMAND:
			switch(wParam)
			{
				case IDM_ARCHIVO_SALIR:		//Menu --> Salir
					PostMessage(hWnd, WM_QUIT, 0, 0L);
					break;

				case IDM_ARCHIVO_DIALOGO:	//Menu --> Dialogo
					//Creamos el nuevo dilogo
					DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG1), hWnd, (DLGPROC) ProcedimientoDialogo);
					break;
			}
			break;

		case WM_LBUTTONDOWN: //Boton Izqdo
			MessageBox(hWnd, "Has hecho click con el boton izquierdo en el rea de cliente.",
			       "Alerta", MB_ICONEXCLAMATION | MB_OK);
			break;
		
		case WM_RBUTTONDOWN: //Boton Dcho
			MessageBox(hWnd, "Has hecho click con el boton derecho en el rea de cliente.", "Alerta",
					   MB_ICONEXCLAMATION | MB_OK);
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;

		case WM_PAINT:

			ValidateRect(hWnd, NULL);
			return 0;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

//----------------------------------------------------------------------------
// Funcin: WinMain
// Propsito; Es la funcin principal de toda aplicacin de Windows
// Se encarga de crear la ventana, mostrarla y es la receptora de los
// mensajes que le son enviados a la aplicacin
//----------------------------------------------------------------------------
INT WINAPI WinMain(HINSTANCE hInstance,			// Instancia a nuestra aplicacin
				   HINSTANCE hPrevInstance,		// Existen instancias previas de nuestra aplicacin?
				   LPSTR lpCmdLine,				// Lnea de comandos
				   int nShowCmd)				// Cmo se despliega nuestra ventana?
{
	
	hInst=hInstance;

	if(!SUCCEEDED(IniVentana(hInstance)))
		return 0;

	
	// Mostrar nuestra ventana
	ShowWindow(g_hWnd, nShowCmd);
	UpdateWindow(g_hWnd);
	
	// Bucle de mensajes tpico de Windows
	MSG	msg;	// handle a un mensaje
	ZeroMemory(&msg, sizeof(msg));

	while(msg.message != WM_QUIT)
	{
		// si se pulsa ESC salimos
		if(GET_KEYDOWN(VK_ESCAPE))
			PostQuitMessage(0);

		if(PeekMessage(&msg, NULL, 0U, 0U, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			//Nuestra funcin de render aqu
		}
	}
	
    // Salir de la aplicacin
	
	UnregisterClass(APP_NAME,hInstance);

	return (0);
}
